/********************************************************************************/
/*																				*/
/********************************************************************************/
#define	uchar	unsigned char
#define	byte	unsigned char
#define	uint	unsigned int
#define	word	unsigned int
#define	ulong	unsigned long
#define	dword	unsigned long
#define	FALSE	0
#define	TRUE	1

#define	NONE		-1
#define	PARITYERR	-2
#define	FRAMEERR	-3
#define	OVERRUNERR	-4

#define	CRLF	"\r\n"
#define	CR		'\r'
#define	LF		'\n'
#define	ESC		0x2B
#define	EXIT	ESC

#include <avr/io.h>									// IO
#include <stdio.h>									//
#include <avr/sfr_defs.h>							// SFR, _BV(bit)
#include <avr/pgmspace.h>							// Flash
#define  CODE PROGMEM
#include <avr/interrupt.h>							// wektory IRQ
#include <avr/wdt.h> 								// WDG
#include <avr/eeprom.h>								// Eeprom
#include <string.h>									// Stringi
#include <compat/deprecated.h>						// sbi, cbi, inb, outb, outp
#define  ebi(port,bit) ( port ^= (1 << (bit)))		// Negowanie bitu na porcie
//#include <util/setbaud.h>							// Uart 0
//#include "include/setbaud1.h"						// Uart 1
#include <util/delay.h>
//#include <util/crc16.h>							// Crc16, Xmodem, Dallas
#include <avr/fuse.h>
#define NOINIT __attribute__ ((section(".noinit")))
#define nop()	__asm__ __volatile__( "nop" )		// Wstawia rozkaz NOP do kodu
#include <avr/sleep.h>
#include <avr/power.h>

    

/********************************************************************************/
/*																				*/
/********************************************************************************/
#define	PioRin	DDRD &= ~(0x07); PORTD &= ~(0x07); DDRC &= ~(0x3F); PORTC &= ~(0x3F); 


#define	SetRa	PORTD |=  (1<<PD2); DDRD  |=  (1<<PD2)
#define	ClrRa	PORTD &= ~(1<<PD2); DDRD  |=  (1<<PD2)

#define	SetRb	PORTD |=  (1<<PD1); DDRD  |=  (1<<PD1)
#define	ClrRb	PORTD &= ~(1<<PD1); DDRD  |=  (1<<PD1)

#define	SetRc	PORTD |=  (1<<PD0); DDRD  |=  (1<<PD0)
#define	ClrRc	PORTD &= ~(1<<PD0); DDRD  |=  (1<<PD0)

#define	SetRd	PORTC |=  (1<<PC5); DDRC  |=  (1<<PC5)
#define	ClrRd	PORTC &= ~(1<<PC5); DDRC  |=  (1<<PC5)

#define	SetRe	PORTC |=  (1<<PC4); DDRC  |=  (1<<PC4)
#define	ClrRe	PORTC &= ~(1<<PC4); DDRC  |=  (1<<PC4)

#define	SetRf	PORTC |=  (1<<PC3); DDRC  |=  (1<<PC3)
#define	ClrRf	PORTC &= ~(1<<PC3); DDRC  |=  (1<<PC3)

#define	SetRg	PORTC |=  (1<<PC2); DDRC  |=  (1<<PC2)
#define	ClrRg	PORTC &= ~(1<<PC2); DDRC  |=  (1<<PC2)

#define	SetRh	PORTC |=  (1<<PC1); DDRC  |=  (1<<PC1)
#define	ClrRh	PORTC &= ~(1<<PC1); DDRC  |=  (1<<PC1)

#define	SetRi	PORTC |=  (1<<PC0); DDRC  |=  (1<<PC0)
#define	ClrRi	PORTC &= ~(1<<PC0); DDRC  |=  (1<<PC0)



#define	PioLin	DDRD &= ~(0xF8); PORTD &= ~(0xF8); DDRB &= ~(0xC3); PORTB &= ~(0xC3); 

#define	SetLa	PORTD |=  (1<<PD3); DDRD  |=  (1<<PD3)
#define	ClrLa	PORTD &= ~(1<<PD3); DDRD  |=  (1<<PD3)

#define	SetLb	PORTD |=  (1<<PD4); DDRD  |=  (1<<PD4)
#define	ClrLb	PORTD &= ~(1<<PD4); DDRD  |=  (1<<PD4)

#define	SetLc	PORTB |=  (1<<PB6); DDRB  |=  (1<<PB6)
#define	ClrLc	PORTB &= ~(1<<PB6); DDRB  |=  (1<<PB6)

#define	SetLd	PORTB |=  (1<<PB7); DDRB  |=  (1<<PB7)
#define	ClrLd	PORTB &= ~(1<<PB7); DDRB  |=  (1<<PB7)

#define	SetLe	PORTD |=  (1<<PD5); DDRD  |=  (1<<PD5)
#define	ClrLe	PORTD &= ~(1<<PD5); DDRD  |=  (1<<PD5)

#define	SetLf	PORTD |=  (1<<PD6); DDRD  |=  (1<<PD6)
#define	ClrLf	PORTD &= ~(1<<PD6); DDRD  |=  (1<<PD6)

#define	SetLg	PORTD |=  (1<<PD7); DDRD  |=  (1<<PD7)
#define	ClrLg	PORTD &= ~(1<<PD7); DDRD  |=  (1<<PD7)

#define	SetLh	PORTB |=  (1<<PB0); DDRB  |=  (1<<PB0)
#define	ClrLh	PORTB &= ~(1<<PB0); DDRB  |=  (1<<PB0)

#define	SetLi	PORTB |=  (1<<PB1); DDRB  |=  (1<<PB1)
#define	ClrLi	PORTB &= ~(1<<PB1); DDRB  |=  (1<<PB1)



#define	MODE	PB2
#define	RdMode	(PINB & (1<<MODE))
enum{TRYB_LINIJKA,					// Zielona linijka z czerwonym punktem pamici
	 TRYB_PUNKT,					// Zielony punkt, z czerwonym punktem pamici
	 TRYB_MULTIKOLOR,				// Zielono/czerwona linikjka z czerown pamic w obszarze czerownym
	 TRYB_MULTIKOLOR_G,				// Zielono czerwona linijka z czerwonym punktem pamici
	 TRYB_MULTIKOLOR_R,				// Zielono czerwona linijka z zielono/czerwonym punktem pamici
	 TRYB_END};
byte Tryb=TRYB_LINIJKA;
byte PamiecR, PamiecL;


enum {COL_R, COL_G};
enum {LED_OFF, LED_ON};
void SetR(byte n, byte col);
void SetL(byte n, byte col);
void demo();
void ClrScr();
void PrtTryb();
void SetLevelRr(char l);
void SetLevelRg(char l);
void SetLevelLr(char l);
void SetLevelLg(char l);
byte WysRr[16];
byte WysRg[16];
byte WysLr[16];
byte WysLg[16];
volatile byte czasMaxL=1, czasMaxR=1, czasVU=1, czasOdsw=1, czasOpadaniaL=1, czasOpadaniaR=1;
word pomiar(byte kanal);
int maxL=0, maxR=0;
int skalowanie(int wartosc);
#define	ADCKANAL_R	6					// Wejcie MUX dla kanau prawego
#define	ADCKANAL_L	7

#define	CZASMAX		700/10				// Czas wywietlania wartoci szczytowej w ms
#define	CZASSRE		 70/10				// czas pomiaru (czstotliwo odwiarzania) wartoci redniej w ms
#define	TIMOPADANIA	300/15*3			// Czas "spadania" waroci maksymalnej do zera w ms





byte EEcfg EEMEM = 0xDC;				// Zapamietanie w eeprom wartoci $dc
byte EEtryb EEMEM = TRYB_LINIJKA;



/*
//------------------------------------------------------------------//
//				Sekcja ".initX"	(ZERO zainicjalizowane)				//
//------------------------------------------------------------------//
unsigned char DnoStosu NOINIT;			// Kontrola stosu
void ClrIntRam(void) __attribute__ ((naked)) __attribute__ ((section (".init3")));
void ClrIntRam(void)
{
unsigned char *AdrRam;
	//--- Zapisujemy od ostatniej zajetej komrki ram do wierzchoka stosu -32 bajty rezerwy ---
	for (AdrRam=&DnoStosu; AdrRam < (unsigned char*)RAMEND-32; AdrRam++)			// Wpisanie do IntRam $FF
		{
		*AdrRam = 0xFF;
		}
}
*/



/*
#ifdef CPULOCK
__attribute__((section (".lock"))) const unsigned char __lock =
0xFC;
#else
	#warning "Nie ustawione LockBits"
#endif
*/




#if defined(__AVR_ATmega8__)
__fuse_t __fuse __attribute__((section (".fuse"))) = 
{
	.high = 0xD9,
	.low = 0x61,
};
#else
	#error "Nie ustawione FuseBits"
#endif




/********************************************************************************/
/*																				*/
/********************************************************************************/
int main()
{
int wynikL, wynikR;
int sreLvu=0, sreRvu=0;
byte cSREG;



	TCCR0 = 0x02;					// Preskaler na 8 ~ 1000000/8 = 125000
	TIMSK =  ( 1<<TOIE0 );			// Zezwolenie na IRQ od przepelnienia timera 0

	demo();

	sei();



	Tryb = eeprom_read_byte( &EEtryb );						// Odczyt trybu pracy
	if (Tryb >= TRYB_END){ Tryb = 0; };
	PrtTryb();												// Wywietl ustawiony tryb
	_delay_ms(800);
	ClrScr();												// Czyszczenie wywietlacza



	//---------------------------------------//
	//-				Ptla gwna			-//
	//---------------------------------------//
	while(1)
		{
		PORTB |= (1<<MODE);									// Podciganie wejcia Mode
//		if (RdMode != 0) Tryb = TRYB_LINIJKA;				// Zdejta zworka to tryb Punkt
//		if (RdMode == 0) Tryb = TRYB_MULTIKOLOR_R;
		if (RdMode == 0)									// Zmiana trybu pracy
			{
			for (cSREG=0; cSREG<100; cSREG++)				// "Odkcanie" 100ms
				{
				_delay_ms(1);
				if (RdMode != 0) goto zaklocenie;
				}
			if ( (++Tryb) >= TRYB_END){ Tryb = 0; };
			cSREG = SREG;									// Zapamietaj stan znacznika I (przerwa)
			eeprom_write_byte( &EEtryb, Tryb);
			SREG = cSREG;									// Odtwrz stan znacznika I (przerwa)

			PrtTryb();										// Wywietl ustawiony tryb

			while( RdMode == 0) nop();						// Czekaj na zwolnienie zworki
			_delay_ms(800);
			ClrScr();										// Czyszczenie wywietlacza
			}
zaklocenie:



		wynikR = pomiar( ADCKANAL_R );						// Kana prawy
		wynikR = skalowanie( wynikR );
		if (wynikR > sreRvu) sreRvu = wynikR;				// Wyniki dla redniej zbieramy przez 10ms
		//--- Warto szczytowa ---//
		if (sreRvu > maxR)	 								// Zapamitanie wartoci szczytowej
			{
			maxR = sreRvu;
			czasMaxR=CZASMAX;								// Zerowanie czasu wartoci szczytowej
			SetLevelRr( maxR );								// Wywietlenie wartoci szczytowej
			}



		wynikL = pomiar( ADCKANAL_L );						// Kana lewy
		wynikL = skalowanie( wynikL );
		if (wynikL > sreLvu) sreLvu = wynikL;
		//--- Warto szczytowa ---//
		if (sreLvu > maxL)	 								// Zapamitanie wartoci szczytowej
			{
			maxL = sreLvu;
			czasMaxL=CZASMAX;								// Zerowanie czasu wartoci szczytowej
			SetLevelLr( maxL );								// Wywietlenie wartoci szczytowej
			}




		if (czasVU == 0)									// Zerowanie wartoci redniej
			{
			czasVU=CZASSRE;
			SetLevelRg( sreRvu );							// Wywietlamy warto redni
			SetLevelLg( sreLvu );
			sreRvu = sreLvu =0;
			}



		if (czasMaxL == 0)									// Zerowanie wartoci szczytowej
			{
			if (czasOpadaniaL == 0)
				{
				czasOpadaniaL = TIMOPADANIA;
				if (maxL != 0)
					{
					maxL--;
					}
				else
					{
					czasMaxL=CZASMAX;
					}
				}
			}
		if (czasMaxR == 0)									// Zerowanie wartoci szczytowej
			{
			if (czasOpadaniaR == 0)
				{
				czasOpadaniaR = TIMOPADANIA;
				if (maxR != 0)
					{
					maxR--;
					}
				else
					{
					czasMaxR=CZASMAX;
					}
				}
			}


		}
}



//----------------------------------------------------------------------//
//						Czyszczenie wywietlacza
//----------------------------------------------------------------------//
void ClrScr()
{
	SetLevelRr( 0 ); SetLevelRg( 0 ); SetLevelLr( 0 ); SetLevelLg( 0 );
}





//----------------------------------------------------------------------//
//						Wywietla tryb pracy
//----------------------------------------------------------------------//
void PrtTryb()
{
	ClrScr();										// Czyszczenie wywietlacza
	WysRr[ Tryb + 1 ] = LED_ON;						// Wywietl ustawiony tryb
	WysLr[ Tryb + 1 ] = LED_ON;
}


//----------------------------------------------------------------------//
//					Skalowanie wyniku pomiaru							//
//----------------------------------------------------------------------//
int skalowanie(int wartosc)
{
// 0dB = 0,775V

	//--- Dla liniowego ---//
	//    BRAK SKALOWANIA

	//--- Dla logarytmicznego ---//
	if (wartosc >= 248*4){ return(15); }
	if (wartosc >= 180*4){ return(14); }
	if (wartosc >= 137*4){ return(13); }
	if (wartosc >= 107*4){ return(12); }
	if (wartosc >=  88*4){ return(11); }
	if (wartosc >=  74*4){ return(10); }
	if (wartosc >=  63*4){ return(9); }
	if (wartosc >=  53*4){ return(8); }
	if (wartosc >=  44*4){ return(7); }
	if (wartosc >=  36*4){ return(6); }
	if (wartosc >=  29*4){ return(5); }
	if (wartosc >=  23*4){ return(4); }
	if (wartosc >=  17*4){ return(3); }
	if (wartosc >=  12*4){ return(2); }
	if (wartosc >=   7*4){ return(1); }
	return( 0 );
}



//----------------------------------------------------------------------//
//					Pomiar sygnau										//
//----------------------------------------------------------------------//
word pomiar(byte kanal)
{
	ADMUX = (3<<REFS0) + kanal;						// Aref=2,56V s.205 noty katalogowej
	ADCSRA = (1<<ADIF);
	ADCSRA = (1<<ADEN) + (1<<ADSC) + (5<<ADPS0);	// zegar = s.207 noty

	while ( (ADCSRA & (1<<ADIF) ) == 0 ) nop();		// Czekaj na koniec kowersji
	return( ADC );
}



//----------------------------------------------------------------------//
//					Czerwony punkt kana prawy							//
//----------------------------------------------------------------------//
void SetLevelRr(char l)
{
byte x;

	if ((Tryb == TRYB_MULTIKOLOR)   ||
		(Tryb == TRYB_MULTIKOLOR_R) ||
		(Tryb == TRYB_MULTIKOLOR_G)    ) return;	// Tryb multikolor po swojemu obsuguje warto maksymaln


	if ( l<0 ) l=0;					// Kontrola zakresu
	if ( l>15 ) l=15;				// Kontrola zakresu


	for (x=0; x<16; x++)			// Wyczy wywietlacz
		{
		WysRr[x] = LED_OFF;
		}
	WysRr[ (byte)l ] = LED_ON;
}



//----------------------------------------------------------------------//
//					Zielona linia kana prawy							//
//----------------------------------------------------------------------//
void SetLevelRg(char l)
{
byte x;

	if ( l<0 ) l=0;					// Kontrola zakresu
	if ( l>15 ) l=15;				// Kontrola zakresu


	if ( (Tryb == TRYB_MULTIKOLOR)   ||
		 (Tryb == TRYB_MULTIKOLOR_R) ||
		 (Tryb == TRYB_MULTIKOLOR_G) )	// Tryb kolorowy
		{
		for (x=0; x<11; x++)		// Odwierz wywietlacz zielony
			{
			if (x>=l)
				{
				WysRg[x] = WysRr[x] = LED_OFF;
				}
			else
				{
				WysRg[x] = LED_ON;
				if (Tryb==TRYB_MULTIKOLOR_R){WysRr[x] = LED_OFF; }	// W multikolorze_r czycimy czerwony wywietlacz 
				}
			}
		for (x=11; x<16; x++)		// Odwierz wywietlacz czerwony
			{
			if (x>l){ WysRg[x] = WysRr[x] = LED_OFF; }
			else{ WysRr[x] = LED_ON; }
			}
		if (maxR < 10)				// Warto szczytowa
			{
			if (Tryb==TRYB_MULTIKOLOR_R){ WysRr[ maxR ] = LED_ON; }
			if (Tryb==TRYB_MULTIKOLOR_G){ WysRg[ maxR ] = LED_ON; }
			}
		else						// W trybie multikolor punkt pamici tylko w obszarze czerwonym
			{
			WysRr[ maxR ] = LED_ON;
			}
		}
	else if (Tryb == TRYB_PUNKT)	// Tryb punkt
		{
		for (x=0; x<16; x++)		// Wyczy wywietlacz
			{
			WysRg[x] = LED_OFF;
			}
		WysRg[ (byte)l ] = LED_ON;
		}
	else							// Tryb linijka
		{
		for (x=0; x<16; x++)		// Odwierz wywietlacz
			{
			if (x>l){ WysRg[x] = LED_OFF; }
			else if (WysRr[x]==LED_ON){ WysRg[x] = LED_OFF; }	// Jeli czerwona wieci, to nie zapalaj zielonej
			else{ WysRg[x] = LED_ON; }
			}
		}
}



//----------------------------------------------------------------------//
//					Czerwony punkt kana lewy							//
//----------------------------------------------------------------------//
void SetLevelLr(char l)
{
byte x;

	if ((Tryb == TRYB_MULTIKOLOR)   ||
		(Tryb == TRYB_MULTIKOLOR_R) ||
		(Tryb == TRYB_MULTIKOLOR_G)    ) return;	// Tryb multikolor po swojemu obsuguje warto maksymaln




	if ( l<0 ) l=0;					// Kontrola zakresu
	if ( l>15 ) l=15;				// Kontrola zakresu


	for (x=0; x<16; x++)			// Wyczy wywietlacz
		{
		WysLr[x] = LED_OFF;
		}
	WysLr[ (byte)l ] = LED_ON;
}



//----------------------------------------------------------------------//
//					Zielona linia kana lewy							//
//----------------------------------------------------------------------//
void SetLevelLg(char l)
{
byte x;

	if ( l<0 ) l=0;					// Kontrola zakresu
	if ( l>15 ) l=15;				// Kontrola zakresu


	if ( (Tryb == TRYB_MULTIKOLOR)   ||
		 (Tryb == TRYB_MULTIKOLOR_R) ||
		 (Tryb == TRYB_MULTIKOLOR_G) )	// Tryb kolorowy
		{
		for (x=0; x<11; x++)		// Odwierz wywietlacz zielony
			{
			if (x>=l)
				{WysLg[x] = WysLr[x] = LED_OFF;
				}
			else
				{
				WysLg[x] = LED_ON;
				if (Tryb==TRYB_MULTIKOLOR_R){WysLr[x] = LED_OFF; }	// W multikolor_R czycimy czerwony wywietlacz 
				}
			}
		for (x=11; x<16; x++)		// Odwierz wywietlacz czerwony
			{
			if (x>l){ WysLg[x] = WysLr[x] = LED_OFF; }
			else{ WysLr[x] = LED_ON; }
			}
		if (maxL < 10)				// Warto szczytowa
			{
			if (Tryb==TRYB_MULTIKOLOR_R){ WysLr[ maxL ] = LED_ON; }
			if (Tryb==TRYB_MULTIKOLOR_G){ WysLg[ maxL ] = LED_ON; }
			}
		else						// W trybie multikolor punkt pamici tylko w obszarze czerwonym
			{
			WysLr[ maxL ] = LED_ON;
			}
		}
	else if (Tryb == TRYB_PUNKT)	// Tryb punkt
		{
		for (x=0; x<16; x++)		// Wyczy wywietlacz
			{
			WysLg[x] = LED_OFF;
			}
		WysLg[ (byte)l ] = LED_ON;
		}
	else							// Tryb linijka
		{
		for (x=0; x<16; x++)		// Odwierz wywietlacz
			{
			if (x>l){ WysLg[x] = LED_OFF; }
			else if (WysLr[x]==LED_ON){ WysLg[x] = LED_OFF; }	// Jeli czerwona wieci, to nie zapalaj zielonej
			else{ WysLg[x] = LED_ON; }
			}
		}
}



//----------------------------------------------------------------------//
//					Demo 												//
//----------------------------------------------------------------------//
void demo()
{
byte x;

	for (x=1; x<16; x++)
		{
		SetR(x,0);
		SetL(x,0);
		_delay_ms(50);
		}
	for (x=16; x>0; x--)
		{
		SetR(x,1);
		SetL(x,1);
		_delay_ms(50);
		}
}


//----------------------------------------------------------------------//
//					Obsuga IRQ od timera 0								//
//----------------------------------------------------------------------//
INTERRUPT( TIMER0_OVF_vect )
{
static byte pozycja=0, dzielnik=0;


	TCNT0 = 256 - 41;									// Przy preskalerze 8 (1MHz / 8) da 3048Hz


	if (WysRg[pozycja] == LED_ON) SetR(pozycja,COL_G);	// Obsuga zielonego
	if (WysLg[pozycja] == LED_ON) SetL(pozycja,COL_G);
	if (WysRr[pozycja] == LED_ON) SetR(pozycja,COL_R);	// Obsuga czerwonego (wyszy priorytet)
	if (WysLr[pozycja] == LED_ON) SetL(pozycja,COL_R);

	
	if (czasOpadaniaL != 0) czasOpadaniaL--;			// Timery 0,3ms
	if (czasOpadaniaR != 0) czasOpadaniaR--;


	if ((++pozycja)>15)	pozycja=0;						// Next pozycja wywietlacza
	if ( (++dzielnik) > 30 )							// Dzielnik dla czasu w 10 ms
		{
		dzielnik = 0;
		if (czasMaxL !=0) czasMaxL--;					// Timery 10 ms
		if (czasMaxR !=0) czasMaxR--;					// Timery 10 ms
		if (czasVU != 0 ) czasVU--;
		if (czasOdsw !=0) czasOdsw--;
		}
}



//----------------------------------------------------------------------//
//																		//
//----------------------------------------------------------------------//
void SetR(byte n, byte col)
{
	PioRin; 
	if (col==COL_G)
		{
		switch(n)
			{
			case(15): 	SetRa; ClrRb; break;		// R1 green
			case(14):	SetRb; ClrRc; break;		// R2 green
			case(13):	SetRa; ClrRc; break;		// R3 green
			case(12):	SetRc; ClrRd; break;		// R4 green
			case(11):	SetRa; ClrRd; break;		// R5 green
			case(10):	SetRd; ClrRe; break;		// R6 green
			case(9):	SetRa; ClrRe; break;		// R7 green
			case(8):	SetRe; ClrRf; break;		// R8 green
			case(7):	SetRa; ClrRf; break;		// R9 green
			case(6):	SetRf; ClrRg; break;		// R10 green
			case(5):	SetRa; ClrRg; break;		// R11 green
			case(4):	SetRg; ClrRh; break;		// R12 green
			case(3):	SetRa; ClrRh; break;		// R13 green
			case(2):	SetRh; ClrRi; break;		// R14 green
			case(1):	SetRa; ClrRi; break;		// R15 green
			}
		}
	else
		{
		switch(n)
			{
			case(15): 	ClrRa; SetRb; break;		// R1 red
			case(14):	ClrRb; SetRc; break;		// R2 red
			case(13):	ClrRa; SetRc; break;		// R3 red
			case(12):	ClrRc; SetRd; break;		// R4 red
			case(11):	ClrRa; SetRd; break;		// R5 red
			case(10):	ClrRd; SetRe; break;		// R6 red
			case(9):	ClrRa; SetRe; break;		// R7 red
			case(8):	ClrRe; SetRf; break;		// R8 red
			case(7):	ClrRa; SetRf; break;		// R9 red
			case(6):	ClrRf; SetRg; break;		// R10 red
			case(5):	ClrRa; SetRg; break;		// R11 red
			case(4):	ClrRg; SetRh; break;		// R12 red
			case(3):	ClrRa; SetRh; break;		// R13 red
			case(2):	ClrRh; SetRi; break;		// R14 red
			case(1):	ClrRa; SetRi; break;		// R15 red
			}
		}
}



//----------------------------------------------------------------------//
//																		//
//----------------------------------------------------------------------//
void SetL(byte n, byte col)
{
	PioLin;
	if (col==COL_G)
		{
		switch(n)
			{
			case(15): 	SetLa; ClrLb; break;		// R1 green
			case(14):	SetLb; ClrLc; break;		// R2 green
			case(13):	SetLa; ClrLc; break;		// R3 green
			case(12):	SetLc; ClrLd; break;		// R4 green
			case(11):	SetLa; ClrLd; break;		// R5 green
			case(10):	SetLd; ClrLe; break;		// R6 green
			case(9):	SetLa; ClrLe; break;		// R7 green
			case(8):	SetLe; ClrLf; break;		// R8 green
			case(7):	SetLa; ClrLf; break;		// R9 green
			case(6):	SetLf; ClrLg; break;		// R10 green
			case(5):	SetLa; ClrLg; break;		// R11 green
			case(4):	SetLg; ClrLh; break;		// R12 green
			case(3):	SetLa; ClrLh; break;		// R13 green
			case(2):	SetLh; ClrLi; break;		// R14 green
			case(1):	SetLa; ClrLi; break;		// R15 green
			}
		}
	else
		{
		switch(n)
			{
			case(15): 	ClrLa; SetLb; break;		// R1 red
			case(14):	ClrLb; SetLc; break;		// R2 red
			case(13):	ClrLa; SetLc; break;		// R3 red
			case(12):	ClrLc; SetLd; break;		// R4 red
			case(11):	ClrLa; SetLd; break;		// R5 red
			case(10):	ClrLd; SetLe; break;		// R6 red
			case(9):	ClrLa; SetLe; break;		// R7 red
			case(8):	ClrLe; SetLf; break;		// R8 red
			case(7):	ClrLa; SetLf; break;		// R9 red
			case(6):	ClrLf; SetLg; break;		// R10 red
			case(5):	ClrLa; SetLg; break;		// R11 red
			case(4):	ClrLg; SetLh; break;		// R12 red
			case(3):	ClrLa; SetLh; break;		// R13 red
			case(2):	ClrLh; SetLi; break;		// R14 red
			case(1):	ClrLa; SetLi; break;		// R15 red
			}
		}
}

